use super::{UResult, UserVerb, UserVerbRef, VerbContext};
use crate::services::spawn::refresh_all_spawn_points;
use async_trait::async_trait;
use log::info;

pub struct Verb;
#[async_trait]
impl UserVerb for Verb {
    async fn handle(
        self: &Self,
        ctx: &mut VerbContext,
        _verb: &str,
        _remaining: &str,
    ) -> UResult<()> {
        info!(
            "Staff-triggered spawn reset by {}",
            ctx.user_dat
                .as_ref()
                .map(|u| u.username.clone())
                .unwrap_or_else(|| "???".to_owned())
        );
        refresh_all_spawn_points(&ctx.trans).await?;
        Ok(())
    }
}
static VERB_INT: Verb = Verb;
pub static VERB: UserVerbRef = &VERB_INT as UserVerbRef;
