use serde::{Deserialize, Serialize};
use std::collections::BTreeSet;

#[derive(Serialize, Deserialize, Clone, Debug, Ord, PartialOrd, Eq, PartialEq)]
pub enum JournalType {
    // Kill journals
    SlayedMeanDog,
    TookOutAKillbot,
    // Visit journals
    JoinedHackerClub,
    // Misc
    Died,
    SharedWithPlayer,
}

#[derive(Serialize, Deserialize, Clone, Debug, Ord, PartialOrd, Eq, PartialEq)]
pub enum JournalInProgress {}

#[derive(Serialize, Deserialize, Clone, Debug, Eq, PartialEq)]
#[serde(default)]
pub struct JournalState {
    pub completed_journals: BTreeSet<JournalType>,
    pub in_progress_journals: Vec<JournalInProgress>,
}

impl Default for JournalState {
    fn default() -> Self {
        Self {
            completed_journals: BTreeSet::new(),
            in_progress_journals: vec![],
        }
    }
}
