use chrono::{DateTime, Utc};
use serde::{Deserialize, Serialize};

#[derive(Serialize, Deserialize, Clone, Debug)]
#[serde(default)]
pub struct Session {
    pub source: String,
    pub last_active: Option<DateTime<Utc>>,
    // Reminder: Consider backwards compatibility when updating this. New fields should generally
    //           be an Option, or you should ensure the default value is sensible, or things will
    //           crash out for existing sessions.
}

impl Default for Session {
    fn default() -> Self {
        Session {
            source: "unknown".to_owned(),
            last_active: None,
        }
    }
}
