#[double]
use crate::db::DBTrans;
use crate::{models::item::Item, DResult};
use mockall_double::double;

pub async fn broadcast_to_room(
    trans: &DBTrans,
    location: &str,
    from_item: Option<&Item>,
    message: &str,
) -> DResult<()> {
    for item in trans.find_items_by_location(location).await? {
        if item.item_type != "player" || item.death_data.is_some() {
            continue;
        }
        if let Some(exclude) = from_item {
            if exclude.item_code == item.item_code && exclude.item_type == item.item_type {
                continue;
            }
        }
        if let Some((session, _session_dat)) =
            trans.find_session_for_player(&item.item_code).await?
        {
            trans.queue_for_session(&session, Some(message)).await?;
        }
    }
    Ok(())
}
