use super::{award_journal_if_needed, JournalChecker, KillSubscriptionType};
#[double]
use crate::db::DBTrans;
use crate::{
    models::{item::Item, journal::JournalType, user::User},
    static_content::species::SpeciesType,
    DResult,
};
use async_trait::async_trait;
use mockall_double::double;

pub struct KillbotChecker;
#[async_trait]
impl JournalChecker for KillbotChecker {
    fn kill_subscriptions(&self) -> Vec<KillSubscriptionType> {
        vec![KillSubscriptionType::SpecificNPCSpecies {
            species: SpeciesType::Robot,
        }]
    }

    async fn handle_kill(
        &self,
        trans: &DBTrans,
        user: &mut User,
        player: &mut Item,
        victim: &Item,
    ) -> DResult<bool> {
        if victim.display.contains("Killbot") {
            award_journal_if_needed(trans, user, player, JournalType::TookOutAKillbot).await
        } else {
            Ok(false)
        }
    }
}

pub static CHECKER: KillbotChecker = KillbotChecker;
