use super::{PossessionData, PossessionType};
use crate::static_content::possession_type::ContainerData;
use once_cell::sync::OnceCell;

pub fn data() -> &'static Vec<(PossessionType, PossessionData)> {
    static D: OnceCell<Vec<(PossessionType, PossessionData)>> = OnceCell::new();
    &D.get_or_init(|| {
        vec![(
            PossessionType::DuffelBag,
            PossessionData {
                display: "duffel bag",
                aliases: vec!["bag"],
                details: "A sturdy bag made from some kind of black synthetic-fibre fabric.\n\n\
                       A single broad strap from one side to another looks like it is intended \
                       to be carried across the shoulder. It looks like it can carry about 20 kgs \
                       of stuff as easily as you could carry 14.4 kgs loose",
                weight: 400,
                container_data: Some(ContainerData {
                    base_weight: 400,
                    compression_ratio: 0.7,
                    ..Default::default()
                }),
                ..Default::default()
            },
        )]
    })
}
