use super::{PossessionData, PossessionType};
use crate::static_content::possession_type::LiquidContainerData;
use once_cell::sync::OnceCell;

pub fn data() -> &'static Vec<(PossessionType, PossessionData)> {
    static D: OnceCell<Vec<(PossessionType, PossessionData)>> = OnceCell::new();
    &D.get_or_init(|| {
        vec![(
            PossessionType::DrinkBottle,
            PossessionData {
                display: "drink bottle",
                aliases: vec!["bottle", "flask", "canteen"],
                details: "A stainless steel bottle, dinged up a bit with dents \
                          and scruff marks from use, but still looking perfectly \
                          usable for whatever fluid you might want it to hold. It \
                          seems to be the right size to hold about 1L.",
                weight: 100,
                liquid_container_data: Some(LiquidContainerData {
                    capacity: 1000,
                    ..Default::default()
                }),
                ..Default::default()
            },
        )]
    })
}
