use crate::static_content::possession_type::EatData;

use super::{ChargeData, PossessionData, PossessionType};
use once_cell::sync::OnceCell;

pub fn data() -> &'static Vec<(PossessionType, PossessionData)> {
    static D: OnceCell<Vec<(PossessionType, PossessionData)>> = OnceCell::new();
    &D.get_or_init(|| vec!(
        (
            PossessionType::GrilledSteak,
            PossessionData {
                display: "grilled steak",
                details: "A mouth-wateringly grilled steak, its outer brown surface a perfect demonstration of the Maillard reaction, with a thin bit of fat adjoining the lean protein",
                weight: 250,
                eat_data: Some(EatData {
                    hunger_impact: -600,
                    thirst_impact: 0,
                }),
                charge_data: Some(ChargeData {
                    max_charges: 20,
                    charge_name_prefix: "bite",
                    charge_name_suffix: "of food",
                }),
                ..Default::default()
            }
        ),
        (
            PossessionType::GreasyBurger,
            PossessionData {
                display: "greasy burger",
                aliases: vec!("burger"),
                details: "A burger with an egg, some bacon, and a comparatively small looking slice of tomato, between two plain white soft burger buns, and slathered in mayonaise",
                weight: 250,
                eat_data: Some(EatData {
                    hunger_impact: -300,
                    thirst_impact: 0,
                }),
                charge_data: Some(ChargeData {
                    max_charges: 20,
                    charge_name_prefix: "bite",
                    charge_name_suffix: "of food",
                }),
                ..Default::default()
            }
        ),
    ))
}
