use super::{PossessionData, PossessionType};
use once_cell::sync::OnceCell;

pub fn data() -> &'static Vec<(PossessionType, PossessionData)> {
    static D: OnceCell<Vec<(PossessionType, PossessionData)>> = OnceCell::new();
    &D.get_or_init(|| {
        vec![(
            PossessionType::RustySpike,
            PossessionData {
                display: "rusty metal spike",
                aliases: vec!["spike"],
                details:
                    "A sharp, rusty spike of metal. You might be able to make something with this, but it is otherwise useless",
                weight: 250,
                ..Default::default()
            },
        )]
    })
}
