use super::{Room, SimpleRoom};
use crate::{
    models::item::Scavtype,
    static_content::{possession_type::PossessionType, scavtable::Scavinfo},
};
use serde_yaml::from_str as from_yaml_str;

pub fn street_scavtable() -> Vec<Scavinfo> {
    vec![Scavinfo {
        possession_type: PossessionType::RustySpike,
        p_present: 1.0,
        difficulty_mean: 7.0,
        difficulty_stdev: 1.0,
        scavtype: Scavtype::Scavenge,
    }]
}

pub fn room_list() -> Vec<Room> {
    from_yaml_str::<Vec<SimpleRoom<()>>>(include_str!("melbs.yaml"))
        .unwrap()
        .into_iter()
        .map(|r| r.into())
        .collect()
}
